from wowool.document.document_interface import DocumentInterface
from striprtf.striprtf import rtf_to_text


class RTFFileInputProvider(DocumentInterface):

    DATA_TYPE = "rtf"

    def __init__(self, fid, encoding="utf8", metadata: dict | None = None):

        self._id = str(fid)
        self.encoding = encoding
        self._data = None
        self._metadata = metadata if metadata is not None else {}

    @property
    def id(self) -> str:
        return self._id

    @property
    def data_type(self) -> str:
        return self.DATA_TYPE

    @property
    def data(self, **kwargs):
        if self._data is not None:
            return self._data

        with open(self.id(), "r") as f:
            data = f.read()
            self._data = rtf_to_text(data, errors="ignore", encoding=self.encoding)
            return self._data

    @property
    def metadata(self) -> dict:
        return self._metadata
